/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lezione120410_libreria;

/**
 *
 * @author utente
 */
public class Libro {

    private String titolo;
    private Autore[] autori;
    private int autore_corrente=0;

    public Libro (String titolo, int nAutori){
        this.titolo=titolo;
        autori=new Autore [nAutori];
    }

    public void addAutore (Autore a){
        if (autore_corrente >= autori.length || isAutore(a)) return;
        autori[autore_corrente]=a;
        autore_corrente++;
    }

    public String getTitolo(){
       return titolo;
    }

    public int getNumeroAutori(){
        return autore_corrente;
    }

    public Autore getAutore(int i){
        if (i<0 || i>= autori.length) return null;
        return autori[i];
    }

    public String toString(){
        String s="Titolo: \""+ titolo +"\"";
        for (int i=0; i<autore_corrente; i++){
           s+= "\nAutore numero "+ (i+1) + ": "+ autori[i].get();
        }
        return s;
        }

    public boolean isAutore(Autore a){
        for (int i=0; i<autore_corrente;i++){
            if (autori[i].equals(a)) return true;
        }
        return false;
    }

    public boolean equals (Libro l){
        //controllo titolo
        if (!titolo.equalsIgnoreCase(l.titolo)) {return false;}
        //controllare il numero di autori
        if (getNumeroAutori() != l.getNumeroAutori()){return false;}
        //ogni autore del libro corrente è autore anche di l
        for (int i=0; i<getNumeroAutori(); i++)
        {
            if (!l.isAutore(getAutore(i))) {return false;}
        }
        return true;
    }


}
